﻿/*
	vLookup receiver is designed to be used in NewForm of child items you create from a vLookup and DFFS enabled parent list, but where the child list does not have DFFS or vLookup enabled.
	If you plan to use DFFS and vLookup in the child list, you don't need this plugin.
*/
/*
JSLint
var $, _spPageContextInfo, setTimeout, clearTimeout, unescape, location, window, getFieldValue, setFieldValue, getUserInfo_v2, vLookupPresetFromUrlDone, ExecuteOrDelayUntilScriptLoaded, SP, alert;
*/

var spjs = spjs || {};
// The file assetpickers.js in SP365 overwrites the $ namespace.
spjs.$ = spjs.$ || $;

spjs.vLookup_NewForm = {
	"vDispName":"1.0 BETA 1",
	"versionDate":"August 16, 2015",
	"fields":null,
	"data":{
		"setFromUrlObj":{fromFields:[],toFields:[]},
		"isSP10":typeof _spPageContextInfo !== "undefined" && _spPageContextInfo.webUIVersion === 4 ? true : false,
		"isSP13":typeof _spPageContextInfo !== "undefined" && _spPageContextInfo.webUIVersion === 15 ? true : false
	},
	"init":function(){
		// Fix for timing issue in SP 2013
		if(spjs.vLookup_NewForm.data.isSP13){
			if(spjs.$("td.ms-formbody span[id*='"+_spPageContextInfo.pageListId.replace(/\{|\}/g,"")+"']").length>0){
				setTimeout(function(){
					spjs.vLookup_NewForm.init();
				},10);
				return;
			}
		}
		spjs.vLookup_NewForm.init_presetFromUrl();
	},
	"init_vLookupFields":function (){
		var res = false, myMatch, disp, fin, type, sIdInp;
		if(spjs.$("td.ms-formbody").length > 0){
			res = {};
		}
		spjs.$("td.ms-formbody").each(function(){
			myMatch = spjs.$(this).html().match(/FieldName="(.+)"\s+FieldInternalName="(.+)"\s+FieldType="(.+)"\s+/);
			if(myMatch!==null){
				// Display name
				disp = myMatch[1];
				// FieldInternalName
				fin = myMatch[2];
				// FieldType
				type = myMatch[3];
				// Build object
				res[fin] = {"tr":this.parentNode,"fin":fin,"disp":disp,"type":type};
			}
		});
		if(res !== false){
			$.each(res,function(f,o){
				if(f.indexOf("_") === 0){
					if(f === "_vLookupID"){
						sIdInp = spjs.$(o.tr).find("input");
						if(sIdInp.length > 0 && sIdInp.val() === ""){
							sIdInp.val(_spPageContextInfo.userId+":"+new Date().valueOf());
						}
					}
					spjs.$(o.tr).hide();
				}
			});
		}
		return res;
	},
	"getUrlKey":function(key){
		var keyVal = "", qpart, urlSearch, split;
		urlSearch = unescape(location.href.replace("_layouts/15/start.aspx#/","").split("?")[1]);
		if(urlSearch.length>0){
			qpart = urlSearch.split('&');
			spjs.$.each(qpart,function(i,item){
				split = item.split('=');
				if(split[0]===key){
					keyVal = split[1];
					if(split.length===3){
						keyVal += split[2];
					}
					return false;
				}
			});
		}
		return keyVal;
	},
	"init_presetFromUrl":function(){
		if(spjs.vLookup_NewForm.fields === null){
			spjs.vLookup_NewForm.fields = spjs.vLookup_NewForm.init_vLookupFields();
		}
		var qs, arr, s, f, t, re, nVal, ui;
		if(window.top.vLookupFromNewOrEditForm !== undefined && window.top.vLookupFromNewOrEditForm.length > 0){ // From NewForm
			$.each(window.top.vLookupFromNewOrEditForm,function(i,o){
				o.fin = o.fin.split("[")[0];
				if(typeof o.val === "string" && o.val.charAt(0)==='{'){
					re = new RegExp("\\{currentUser:[^\}]*\\}","g");
					if(o.val.match(re) !== null){
						spjs.$.each(o.val.match(re),function(i,m){
							nVal = m.replace(/\{|\}/g,"").split(":")[1];
							ui = getUserInfo_v2(_spPageContextInfo.userId,nVal);
							nVal = ui[nVal] !== null ? ui[nVal] : "[The property \""+nVal+"\" was not found]";
							setFieldValue(o.fin,o.val.replace(m,nVal));
						});
					}else{ // Set text values from URL
						setFieldValue(o.fin,o.val.replace(/{|}/g,""));						
					}
				}else{
					if(spjs.vLookup_NewForm.fields[o.fin].type === "SPFieldLookupMulti"){
						spjs.vLookup_NewForm.setlookupValue(o.fin,o.val);
					}else{
						setFieldValue(o.fin,o.val);
					}
				}
				if(o.hide){
					spjs.$(spjs.vLookup_NewForm.fields[o.fin].tr).hide().addClass("spjshidden");
				}
				if(typeof vLookupPresetFromUrlDone === "function"){
					vLookupPresetFromUrlDone(o.fin);
				}
			});
			window.top.vLookupFromNewOrEditForm = [];
		}else{ // From DispForm
			qs = spjs.vLookup_NewForm.getUrlKey('getFromParent');
			if(qs!==''){
				arr = qs.split('~');
				if(arr.length>0){
					spjs.$.each(arr,function(i,raw){
						s = raw.split('|');
						if(s.length===3){
							f = s[0];
							t = s[1];
							if(f.charAt(0)==='{'){
								re = new RegExp("\\{currentUser:[^\}]*\\}","g");
								if(f.match(re) !== null){
									spjs.$.each(f.match(re),function(i,m){
										nVal = m.replace(/\{|\}/g,"").split(":")[1];
										ui = getUserInfo_v2(_spPageContextInfo.userId,nVal);
										nVal = ui[nVal] !== null ? ui[nVal] : "[The property \""+nVal+"\" was not found]";
										setFieldValue(t,f.replace(m,nVal));
									});
								}else{ // Set text values from URL
									setFieldValue(t,f.replace(/{|}/g,""));
									if(typeof vLookupPresetFromUrlDone === "function"){
										vLookupPresetFromUrlDone(t);
									}
								}
							}else{
								spjs.vLookup_NewForm.data.setFromUrlObj.fromFields.push(f);
								spjs.vLookup_NewForm.data.setFromUrlObj.toFields.push(t);
							}
							if(s[2]==='true'){
								spjs.$(spjs.vLookup_NewForm.fields[t].tr).hide().addClass("spjshidden");
							}
						}
					});
					ExecuteOrDelayUntilScriptLoaded(spjs.vLookup_NewForm.do_presetFromUrl, "sp.js");
				}
			}
		}
	},
	"do_presetFromUrl":function(){
		var guid, qf = "ID", pid, cc, baseUrl, list, qb, camlQuery, collListItem, val, vArr;
		guid = spjs.vLookup_NewForm.getUrlKey('parentListGuid');
		pid = spjs.vLookup_NewForm.getUrlKey('parentItemId');
		if(pid.indexOf(":")>-1){
			qf = "_vLookupID";
 		}
		baseUrl = spjs.vLookup_NewForm.getUrlKey('baseUrl');
		if(baseUrl === ''){
			baseUrl = '/';
		}
		cc = new SP.ClientContext(baseUrl);
		list = cc.get_web().get_lists().getById(guid);
		qb = [];
		qb.push("<View Scope='RecursiveAll'><Query>");
		qb.push("<Where><Eq><FieldRef Name='"+qf+"' /><Value Type='Text'>"+pid+"</Value></Eq></Where>");
		qb.push("</Query></View>");
		camlQuery = new SP.CamlQuery();
		camlQuery.set_viewXml(qb.join(''));
		collListItem = list.getItems(camlQuery);
		cc.load(collListItem);//, "Include("+spjs.vLookup_NewForm.data.setFromUrlObj.fromFields.toString()+")");
		cc.executeQueryAsync(
			function(sender, args){
				if(collListItem.get_count() === 0){
					// No parent found
					return;
				}
				var currentItem = collListItem.itemAt(0), format = "";				
				spjs.vLookup_NewForm.data.parentItemId = currentItem.get_item("ID");
				spjs.$.each(spjs.vLookup_NewForm.data.setFromUrlObj.fromFields,function(i,fin){
					if(spjs.vLookup_NewForm.data.setFromUrlObj.toFields[i].match(/\[(.*?)\]/) !== null){
						format = spjs.vLookup_NewForm.data.setFromUrlObj.toFields[i].match(/\[(.*?)\]/);
						spjs.vLookup_NewForm.data.setFromUrlObj.toFields[i] = spjs.vLookup_NewForm.data.setFromUrlObj.toFields[i].split("[")[0];
						format = format[1];
					}
					if(spjs.$(spjs.vLookup_NewForm.fields[spjs.vLookup_NewForm.data.setFromUrlObj.toFields[i]].tr).length === 0){
						alert("[vLookup "+spjs.vLookup_NewForm.vDispName+"]\nYou are trying to fill in the field \""+spjs.vLookup_NewForm.data.setFromUrlObj.toFields[i]+"\" from the parent field \""+fin+"\".\n\nThe field \""+spjs.vLookup_NewForm.data.setFromUrlObj.toFields[i]+"\" could not be found in the form at \""+location.pathname+"\". Ensure you are using the correct FieldInternalName.");
						return;
					}
					val = (currentItem.get_item(fin)!==null)?currentItem.get_item(fin):'';
					if(fin==='FileDirRef'){
						val = val+"/DispForm.aspx?ID="+pid;
					}
					if(spjs.$(spjs.vLookup_NewForm.fields[spjs.vLookup_NewForm.data.setFromUrlObj.toFields[i]].tr).length === 0){
						// content type where the field is not present?
						return;
					}
					if(spjs.vLookup_NewForm.fields[spjs.vLookup_NewForm.data.setFromUrlObj.toFields[i]].type.match('SPFieldLookup') !== null){
						spjs.vLookup_NewForm.setlookupValue(spjs.vLookup_NewForm.data.setFromUrlObj.toFields[i],val);
					}else{
						if(typeof val === 'object'){
							if(!spjs.$.isArray(val)){
								val = [val];
							}
							vArr = [];
							spjs.$.each(val,function(j,o){
								if(spjs.$.isArray(o)){
									spjs.$.each(o,function(k,p){
										if(p.get_lookupValue!==undefined){
											vArr.push(p.get_lookupValue());
										}
									});
								}else{
									if(o.get_lookupValue!==undefined){
										if(spjs.vLookup_NewForm.fields[spjs.vLookup_NewForm.data.setFromUrlObj.toFields[i]].type.match('SPFieldUser')!==null){
											vArr.push(getUserInfo_v2(o.get_lookupId()).Name); // Find loginName
										}else{
											vArr.push(o.get_lookupValue()); // DisplayName
										}
									}else{
										if(o.getFullYear !== undefined){
											if(format === ""){
												alert("You are attempting to get the value from a date column using vLookup.\n\nPlease go to the configuration and specify the date format in the \"To field\" under the \"Prefill values\" section.\n\nSee the help icon in the vLookup setup for instructions.");
												return;
											}else{
												format = format.replace("MM",(o.getMonth()+1) < 10 ? "0"+(o.getMonth()+1) : (o.getMonth()+1));
												format = format.replace("dd",o.getDate() < 10 ? "0"+o.getDate() : o.getDate());
												format = format.replace("yyyy",o.getFullYear());
												format = format.replace("yy",o.getFullYear().toString().substring(2));
												format = format.replace("hh",o.getHours() < 10 ? "0"+o.getHours() : o.getHours());
												format = format.replace("mm",o.getMinutes() < 10 ? "0"+o.getMinutes() : o.getMinutes());
												format = format.replace("ss",o.getSeconds() < 10 ? "0"+o.getSeconds() : o.getSeconds());
												o = format;
											}
										}
										vArr.push(o);
									}
								}
							});
							if(spjs.vLookup_NewForm.fields[spjs.vLookup_NewForm.data.setFromUrlObj.toFields[i]].type.match('SPFieldUser')!==null){
								val = vArr.join("; ");
							}else{
								val = vArr.join(", ");
							}
						}
						if(spjs.vLookup_NewForm.data.debug){
							spjs.vLookup_NewForm.writeDebug("Setting field \""+spjs.vLookup_NewForm.data.setFromUrlObj.toFields[i]+"\" to \""+unescape(val)+"\"");
						}
						setFieldValue(spjs.vLookup_NewForm.data.setFromUrlObj.toFields[i],unescape(val),true);
					}
					if(typeof vLookupPresetFromUrlDone === "function"){
						vLookupPresetFromUrlDone(spjs.vLookup_NewForm.data.setFromUrlObj.toFields[i]);
					}
				});
			},
			function(sender, args){
				alert("[vLookup "+spjs.vLookup_NewForm.vDispName+" - PresetFromURL]\n\nError:\n*****************\n" + args.get_message()+"\n\nCAML\n*****************\n"+qb.join('')+"\n\nList:\n*****************\n"+guid+"\n\nBaseUrl:\n*****************\n"+baseUrl+"\n\nParentID:\n*****************\n"+pid);
			}
		);
	},
	"setlookupValue":function(fin,newVal){
		var lVal, lId, thisField, fType, inputField, inputFieldHidden, split, timer = 0;
		thisField = spjs.$(spjs.vLookup_NewForm.fields[fin].tr);
		fType = spjs.vLookup_NewForm.fields[fin].type;
		if(!spjs.$.isArray(newVal)){
			newVal = [newVal];
		}
		spjs.$.each(newVal,function(i,val){
			if(typeof val === "object"){
				lVal = val.get_lookupValue();
				lId = String(val.get_lookupId());
			}else{
				lVal = String(val);
				lId = String(val);
			}
			switch(fType){
				case 'SPFieldLookup':
					// Try setting text first
					thisField.find('select option').each(function(){
						if(spjs.$(this).text()===lVal){
							spjs.$(this).parent().val(spjs.$(this).val());
						}
					});
					// If value is not set - try with ID
					if(thisField.find('option:selected').text().toString() !== lVal.toString()){
						thisField.find('select').val(lId);
					}
					if(thisField.find('input').length>0){
						spjs.$("#"+thisField.find('input').attr("opthid")).val(lId);
					}
				break;
				case 'SPFieldLookup_Input':
					inputField = thisField.find('input.ms-lookuptypeintextbox');
					inputFieldHidden = spjs.$("*[id='"+inputField.attr('optHid')+"']");
					split = inputField.attr('choices').split('|');
					// Try setting text first
					spjs.$.each(split,function(i,val){
						if(i%2!==0){
							return;
						}
						if(val===lVal){
							inputField.val(split[i]);
							inputFieldHidden.val(split[i+1]);
							return false;
						}
					});
					// If value is not set - try with ID
					if(getFieldValue(fin) !== lVal){
						spjs.$.each(split,function(i,val){
							if(i%2===0){
								return;
							}
							if(val===lId){
								inputField.val(split[i-1]);
								inputFieldHidden.val(split[i]);
								return false;
							}
						});
					}
				break;
				case 'SPFieldLookupMulti':
					clearTimeout(timer);
					if(thisField.find('select:first option:first').prop('spjs') !== "1"){
						thisField.find('select:first option:first').prop('selected', false);
					}
					if(String(parseInt(lId,10)) === String(lId)){
						thisField.find('select:first').find("option").filter(function() {
							return spjs.$(this).val() === lId; 
						}).prop({"spjs":"1","selected":true});
					}else{
						thisField.find('select:first').find("option").filter(function() {
							return spjs.$(this).text() === lId; 
						}).prop({"spjs":"1","selected":true});
					}
					timer = setTimeout(function(){
						thisField.find("input[type='button']:first").trigger("click");
					},100);
				break;
			}
		});
	}
};